class NoticeLevel {
  final String name;
  final int priority;

  const NoticeLevel(this.priority, this.name);

  static const trace = NoticeLevel(1000, 'TRACE');
  static const debug = NoticeLevel(2000, 'DEBUG');
  static const info = NoticeLevel(3000, 'INFO');
  static const warn = NoticeLevel(4000, 'WARN');
  static const error = NoticeLevel(5000, 'ERROR');
  static const fatal = NoticeLevel(6000, 'FATAL');

  @override
  operator == (Object other) {
    if (other is NoticeLevel) {
      return priority == other.priority;
    } else {
      return false;
    }
  }
  
  @override
  int get hashCode => priority.hashCode;  

  @override
  String toString() => name;
}
