import 'package:fast_immutable_collections/fast_immutable_collections.dart';
import 'package:notice/notice.dart';
import 'package:notice/src/notice_reciever.dart';
import 'package:notice/src/notice_record.dart';

mixin NoticeLogger implements NoticeReceiver {
  void log(NoticeLevel level, String message, {Object? error, StackTrace? stackTrace}) {
    final record = NoticeRecord(
      level: level,
      message: message,
      error: error,
      stackTrace: stackTrace,
      timestamp: DateTime.now(),
      breadcrumbs: const IListConst([]),
    );
    onRecord(record);
  }

  void trace(String message, {Object? error, StackTrace? stackTrace}) {
    log(NoticeLevel.trace, message, error: error, stackTrace: stackTrace);
  }

  void debug(String message, {Object? error, StackTrace? stackTrace}) {
    log(NoticeLevel.debug, message, error: error, stackTrace: stackTrace);
  }

  void info(String message, {Object? error, StackTrace? stackTrace}) {
    log(NoticeLevel.info, message, error: error, stackTrace: stackTrace);
  }

  void warn(String message, {Object? error, StackTrace? stackTrace}) {
    log(NoticeLevel.warn, message, error: error, stackTrace: stackTrace);
  }

  void error(String message, {Object? error, StackTrace? stackTrace}) {
    log(NoticeLevel.error, message, error: error, stackTrace: stackTrace);
  }

  void fatal(String message, {Object? error, StackTrace? stackTrace}) {
    log(NoticeLevel.fatal, message, error: error, stackTrace: stackTrace);
  }
}
