import 'package:fast_immutable_collections/fast_immutable_collections.dart';
import 'package:meta/meta.dart';
import 'package:notice/src/notice_level.dart';

class NoticeRecord {
  final NoticeLevel level;
  final String message;
  final Object? error;
  final StackTrace? stackTrace;
  final DateTime timestamp;
  final IList<String> breadcrumbs;

  const NoticeRecord({
    required this.level,
    required this.message,
    required this.error,
    required this.stackTrace,
    required this.timestamp,
    required this.breadcrumbs,
  });

  @internal
  NoticeRecord copyWithBreadcrumb(String breadcrumb) {
    return NoticeRecord(
      level: level,
      message: message,
      error: error,
      stackTrace: stackTrace,
      timestamp: timestamp,
      // append breadcrumb to the front of the list
      breadcrumbs: breadcrumbs.insert(0, breadcrumb),
    );
  }
}
