import 'package:meta/meta.dart';
import 'package:notice/src/notice_reciever.dart';
import 'package:notice/src/notice_record.dart';

/// allows registering one or more notices without knowing their parent yet
/// [globalNoticeRegistry] is a global instance of this class and is typically used to register
/// package level notices to defer their output behavior to the package user
class NoticeRegistry implements NoticeReceiver {
  final List<NoticeReceiver> _receivers = List.empty(growable: true);

  NoticeRegistry();

  @internal
  void connect(NoticeReceiver notice) {
    _receivers.add(notice);
  }

  @override
  void onRecord(NoticeRecord record) {
    for (final receiver in _receivers) {
      receiver.onRecord(record);
    }
  }
}
