import 'package:notice/src/notice_output.dart';
import 'package:notice/src/notice_record.dart';

class ConsoleOutput implements NoticeOutput {
  @override
  void onRecord(NoticeRecord record) {
    final output = StringBuffer();
    output.write(record.timestamp.toIso8601String());
    if (record.breadcrumbs.isNotEmpty) {
      output.write(' ');
      output.write(record.breadcrumbs.join('.'));
    }
    output.write(' ');
    output.write(record.level);
    output.write(': ');
    output.write(record.message);
    if (record.error != null) {
      output.write('\n');
      output.write(record.error);
    }
    if (record.stackTrace != null) {
      output.write('\n');
      output.write(record.stackTrace);
    }
    print(output);
  }
}
